unit fdemo1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus,  ExtCtrls, ComCtrls, Variants;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Close1: TMenuItem;
    Change1: TMenuItem;
    Term1: TMenuItem;
    N1: TMenuItem;
    xmin1: TMenuItem;
    xmax1: TMenuItem;
    ymin1: TMenuItem;
    ymax1: TMenuItem;
    Showinfo1: TMenuItem;
    Rescale1: TMenuItem;
    PaintBox1: TPaintBox;
    N2: TMenuItem;
    Resolution1: TMenuItem;
    StatusBar1: TStatusBar;
    procedure Showinfo1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure Term1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure Rescale1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    xmin, xmax, ymin, ymax: extended;
    ymincur, ymaxcur: extended;
    resolution: integer;
    Functionparser:VARIANT;
  end;

var
  Form1: TForm1;

implementation
uses ComObj;
{$R *.DFM}

{(*1*),(*2*),(*3*) and (*Aa*) were performed at design time}

procedure TForm1.PaintBox1Paint(Sender: TObject);
var i: integer;
    x,y: extended;
    oldvalid, newvalid: boolean;
    mx, my, tx, ty: extended;
    ec:integer;
begin
  ec:=FunctionParser.ErrorCode;
  if not(ec in [0,7]) then exit;     (*Db*)
     {0: OK, 7: undefined function value for PREVIOUS x }
  statusbar1.panels[0].text:='displayed x-range: '+floattostrF(xmin,fffixed,3,2)
                            +' ... '+floattostrF(xmax,fffixed,3,2);
  statusbar1.panels[1].text:='displayed y-range: '+floattostrF(ymin,fffixed,3,2)
                            +' ... '+floattostrF(ymax,fffixed,3,2);
  ymincur:=1e4000;
  ymaxcur:=-1e4000;
  caption:=FunctionParser.Term;
  mx:=paintbox1.width/(xmax-xmin);
  tx:=mx*xmin;
  my:=paintbox1.height/(ymin-ymax);
  ty:=my*ymax;
  oldvalid:=false;
  paintbox1.canvas.pen.color:=clred;
  for i:=0 to RESOLUTION do begin
    x:=xmin+i*(xmax-xmin)/RESOLUTION;
    FunctionParser.SetVarValue('x',x);   (*5*)
    y:=FunctionParser.Result;           (*6*)
    if y>ymaxcur then ymaxcur:=y;
    if y<ymincur then ymincur:=y;
    newvalid:=FunctionParser.ErrorCode=0;   (*Db*)
    if newvalid then begin
      if oldvalid then
        Paintbox1.canvas.lineto(round(mx*x-tx),round(my*y-ty))
        else  Paintbox1.canvas.moveto(round(mx*x-tx),round(my*y-ty));
    end;
    oldvalid:=newvalid;
  end;
  with paintbox1.canvas do begin
    pen.color:=clblack;             {axes}
    moveto(round(mx*xmin-tx),-round(ty));
    lineto(round(mx*xmax-tx),-round(ty));
    moveto(-round(tx),round(my*ymax-ty));
    lineto(-round(tx),round(my*ymin-ty));
  end;
end;

procedure TForm1.Term1Click(Sender: TObject);
var h: string;
    q: extended;
begin
  if sender = term1
    then begin
      h:=FunctionParser.Term;
      FunctionParser.Term:=inputbox('Graphic Demo','Enter the new Term',h);(*4*)
      if FunctionParser.ErrorCode<>0                        (*Db*)
        then begin
             caption:='';
             showmessage(FunctionParser.ErrorMessage); end
    end
    else begin
      if sender = xmin1 then h:=floattostr(xmin) else
       if sender = xmax1 then h:=floattostr(xmax) else
       if sender = ymin1 then h:=floattostr(ymin) else
       if sender = ymax1 then h:=floattostr(ymax) else
       if sender = resolution1 then h:=inttostr(resolution);
       h:=inputbox('Graphic Demo','Enter the new value',h);
       q:=strtofloat(h);
       if sender = xmin1 then xmin:=q else
       if sender = xmax1 then xmax:=q else
       if sender = ymin1 then ymin:=q else
       if sender = ymax1 then ymax:=q else
       if sender = resolution1 then resolution:=strtoint(h);
    end;
    rescale1.enabled:=true;
    paintbox1.repaint;
end;

function twice(x:extended):extended; {sample user function}
begin
 result:=2*x;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  icon.Assign(application.Icon);
  xmin:=0; xmax:=35;
  ymin:=-3.5; ymax:=3.5;
  resolution:= 200;
  try
   FunctionParser:=CreateOleObject('mhgspars.FunctionParser');
   FunctionParser.Term:='sin(x)*ln(x+1)'; (*4*) {Term is initialized here}
  except
    showmessage('Sorry, TFunctionParser is not available on this computer.');
    application.terminate;
  end;
end;

procedure TForm1.Rescale1Click(Sender: TObject);
begin
  ymin:=ymincur;
  ymax:=ymaxcur;
  paintbox1.repaint;
  rescale1.enabled:=false;
end;

procedure TForm1.Showinfo1Click(Sender: TObject);
begin
  FunctionParser.ShowInfo;
end;

procedure TForm1.Close1Click(Sender: TObject);
begin
  application.terminate;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  statusbar1.panels[0].width:=paintbox1.width div 2;
  statusbar1.panels[1].width:=paintbox1.width div 2;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 if not varisempty(functionparser) then
   functionparser.cleanup;
end;

end.
